-- MetricIntegrationExample
SELECT 'http://localhost/QPR2015-1/Portal/QPR.Isapi.dll/wsforward/MainService.svc/webHttp' AS VAL INTO #BaseUrl;
SELECT 'qpr' AS VAL INTO #LogOnName;
SELECT 'demo' AS VAL INTO #Password;
SELECT 'Dentorex Group Scorecard' AS VAL INTO #MetricsModelName

-- Create a table for setting new values.
CREATE TABLE #METRICSVALUES
(
	Id Int NOT NULL IDENTITY(1,1),
	Scorecard VARCHAR(80),
	Element VARCHAR(80),
	Series VARCHAR(3),
	Period VARCHAR(20),
	Value VARCHAR(20)
);

INSERT INTO #METRICSVALUES (Scorecard, Element, Series, Period, Value)
 VALUES ('DENGROUP', 'ECOMMERCESALES', 'ACT', '$Q1/2014', '201');
INSERT INTO #METRICSVALUES (Scorecard, Element, Series, Period, Value)
 VALUES ('DENGROUP', 'ECOMMERCESALES', 'ACT', '$Q2/2014', '235');
INSERT INTO #METRICSVALUES (Scorecard, Element, Series, Period, Value)
 VALUES ('DENGROUP', 'ECOMMERCESALES', 'ACT', '$Q3/2014', '247');
INSERT INTO #METRICSVALUES (Scorecard, Element, Series, Period, Value)
 VALUES ('DENGROUP', 'ECOMMERCESALES', 'ACT', '$Q4/2014', '199');
INSERT INTO #METRICSVALUES (Scorecard, Element, Series, Period, Value)
 VALUES ('DENGROUP', 'ECOMMERCESALES', 'ACT', '$Q1/2015', '230');
INSERT INTO #METRICSVALUES (Scorecard, Element, Series, Period, Value)
 VALUES ('DENGROUP', 'ECOMMERCESALES', 'ACT', '$Q2/2015', '251');
INSERT INTO #METRICSVALUES (Scorecard, Element, Series, Period, Value)
 VALUES ('DENGROUP', 'ECOMMERCESALES', 'ACT', '$Q3/2015', '260');
INSERT INTO #METRICSVALUES (Scorecard, Element, Series, Period, Value)
 VALUES ('DENGROUP', 'ECOMMERCESALES', 'ACT', '$Q4/2015', '217');

(SELECT 'ProjectId', convert(nvarchar, @_ProjectId)) UNION ALL
(SELECT 'DataTableName', 'MetricsData') UNION ALL
(SELECT 'Append', '0')
(SELECT * FROM [#METRICSVALUES])
--#ImportDataTable

SELECT * FROM [#METRICSVALUES];
(SELECT 'Title', 'MetricsData') UNION ALL
(SELECT 'SheetName', 'MetricsData') UNION ALL
(SELECT 'MaximumCount', '0')
--#ShowReport
 
-- Set values that are specific for UpdateMetricsValues
SELECT 'MetricsData' AS VAL INTO #DataTableName;
-------------------------------------------------------------
-- Set script ID for UpdateMetricsValues
-------------------------------------------------------------
SELECT '22' AS VAL INTO #SubScriptId;	-- UpdateMetricsValues
(SELECT 'ScriptId', '21')	-- Set script ID for SetupMetricsConnection
--#Run

-- Create a table describing new Elements.
CREATE TABLE #ELEMENTS
(
	Id Int NOT NULL IDENTITY(1,1),
	Element VARCHAR(80),
	Typename VARCHAR(30),
	Parent VARCHAR(80),
	Description VARCHAR(8000),
	Symbol VARCHAR(200)
);

-- Insert values for demonstration series
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol, Description)
 VALUES ('Scorecard for Project A', 'Scorecard', null, 'SC_DEMO_1', 'Description for Project A scorecard.');
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol, Description)
 VALUES ('Project A', 'Project', 'Scorecard for Project A', 'PROJECT_DEMO_1', 'Description for Project A.');
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol)
 VALUES ('Scorecard for Project B', 'Scorecard', null, 'SC_DEMO_2');
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol)
 VALUES ('Project B', 'Project', 'Scorecard for Project B', 'PROJECT_DEMO_2');
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol)
 VALUES ('Milestone A1', 'Project Milestone', 'Project A', 'MS_DEMO_1');
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol)
 VALUES ('Milestone A2', 'Project Milestone', 'Project A', 'MS_DEMO_2');
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol)
 VALUES ('Milestone B1', 'Project Milestone', 'Project B', 'MS_DEMO_3');
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol)
 VALUES ('Milestone B2', 'Project Milestone', 'Project B', 'MS_DEMO_4');
INSERT INTO #ELEMENTS (Element, Typename, Parent, Symbol)
 VALUES ('Milestone B3', 'Project Milestone', 'Project B', 'MS_DEMO_5');
 
(SELECT 'ProjectId', convert(nvarchar, @_ProjectId)) UNION ALL
(SELECT 'DataTableName', 'NewElements') UNION ALL
(SELECT 'Append', '0')
(SELECT * FROM [#ELEMENTS])
--#ImportDataTable

SELECT * FROM [#ELEMENTS];
(SELECT 'Title', 'NewElements') UNION ALL
(SELECT 'SheetName', 'NewElements') UNION ALL
(SELECT 'MaximumCount', '0')
--#ShowReport

-- Set new values to applicable temporary tables
DROP TABLE #DataTableName;
SELECT 'NewElements' AS VAL INTO #DataTableName;
DROP TABLE #SubScriptId;
-------------------------------------------------------------
-- Set script ID for CreateMetricsElements and call the script
-------------------------------------------------------------
SELECT '26' AS VAL INTO #SubScriptId;
(SELECT 'ScriptId', '21')	-- ID for SetupMetricsConnection
--#Run

-- Finally, show what elements were created.
(SELECT 'ProjectId', convert(nvarchar, @_ProjectId)) UNION ALL
(SELECT 'DataTableName', 'CreatedScorecards') UNION ALL
(SELECT 'Append', '0')
(SELECT * FROM [#ElementIdMap])
--#ImportDataTable

SELECT * FROM [#ElementIdMap];
(SELECT 'Title', 'Created Scorecards') UNION ALL
(SELECT 'SheetName', 'CreatedScorecards') UNION ALL
(SELECT 'MaximumCount', '0')
--#ShowReport
